
/*
 * Saibamaze, 4/21/2020
 */


#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
//#include <avr/pgmspace.h>

//TIMER
unsigned long lastActivity;
unsigned long currentTime;
unsigned long lastWait;
unsigned long lastBlink;
int period = 25000;
int blinkPeriod = 6000;

//BUTTONS
const int button4Pin = 6;
const int button3Pin = 5; 
const int button2Pin = 4;
const int button1Pin = 3;
int button4State = 0;
int button3State = 0;
int button2State = 0;
int button1State = 0;
#define ACTIVATED LOW

//SOUND
const int sound = 7;

//LIGHT
const int light = 2;

//SCREEN
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);

//GRAPHICS
void neutral(){
  //display.clearDisplay();
  display.setTextSize(2);
  display.setCursor(24,9);
  display.println("[0] [0]");
  display.println("     U");
  //display.display();
}

void crazy(){
  //display.clearDisplay();
  display.setTextSize(2);
  display.setCursor(24,9);
  display.println("[@] [@]");
  display.println("     ~");
  //display.display();
}

void happy(){
  //display.clearDisplay();
  display.setTextSize(2);
  display.setCursor(24,9);
  display.println("[^] [^]");
  display.println("    \\/");
  //display.display();
}

void wow(){
  //display.clearDisplay();
  display.setTextSize(2);
  display.setCursor(24,9);
  display.println("[0] [0]"); 
  display.println("     O");
  //display.display();
}

void meh(){
  //display.clearDisplay();
  display.setTextSize(2);
  display.setCursor(24,9);
  display.println("[0] [0]"); 
  display.println("     -");
 // display.display();
}

void left(){
 // display.clearDisplay();
  display.setTextSize(2);
  display.setCursor(24,9);
  display.println("[<] [<]"); 
  display.println("     -");
 // display.display();
}

void right(){
 // display.clearDisplay();
  display.setTextSize(2);
  display.setCursor(24,9);
  display.println("[>] [>]"); 
  display.println("     -");
  //display.display();
}

void wink(){
 // display.clearDisplay();
  display.setTextSize(2);
  display.setCursor(24,9);
  display.println("[-] [0]"); 
  display.println("     U");
 // display.display();
}

void blink(){
 // display.clearDisplay();
  display.setTextSize(2);
  display.setCursor(24,9);
  display.println("[-] [-]"); 
  display.println("     U");
 // display.display();
}

void speak(String sentance){
  for(int i = 0; i < sentance.length()/4; i++){
    display.clearDisplay();
    wow();
    tone(sound,random(200,700),100);
    display.setTextSize(.8);
    display.setCursor(0,42);
    display.println(sentance);
    display.display();
    delay(100);
    display.clearDisplay();
    meh();
    tone(sound,random(200,700),100);
    display.setTextSize(.8);
    display.setCursor(0,42);
    display.println(sentance);
    display.display();
    delay(100);
  }
}

//GENERATOR
char* array1[] = { //3 options
//"The answer is simple. Choose: ",
"The council has decided upon: ",
"The pragmatic approach would be: ",
"Logisitics ran, stats say: ",
};

char* array2[] = { //4 options
"MIDDLE EAST OFFENSIVE",
"CUBAN PARAMILITARY",
"HONGKONG VARIANT",
"TURKISH DECOY"
};


char* generator1(){
  return array1[random(0,4)];
}

char* generator2(){
  return array2[random(0,5)];
}


void setup() {
  //BUTTONS
  pinMode(button1Pin, INPUT);
  pinMode(button2Pin, INPUT);
  pinMode(button3Pin, INPUT);
  pinMode(button4Pin, INPUT);
  digitalWrite(button1Pin, HIGH);
  digitalWrite(button2Pin, HIGH);
  digitalWrite(button3Pin, HIGH);
  digitalWrite(button4Pin, HIGH);
  randomSeed(analogRead(0));

  //SOUND
  pinMode(sound,OUTPUT);

  //LIGHT
  pinMode(light,OUTPUT);
  digitalWrite(light,HIGH);

  //SCREEN
  Serial.begin(115200);
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // Address 0x3D for 128x64
    Serial.println(F("SSD1306 allocation failed"));
    for(;;);
  }
  display.clearDisplay();
  display.setTextColor(WHITE); 

  //STARTUP
  display.setTextSize(2);
  display.setCursor(30,30);
  display.println("HELLOOO!");
  display.display();
  tone(sound,500,150);
  delay(150);
  tone(sound,450,150);
  delay(150);
  tone(sound,500,150);
  delay(150);
  tone(sound,450,150);
  delay(150);
  tone(sound,450,150);
  delay(150);
  tone(sound,500,150);
  delay(150);
  tone(sound,550,150);
  delay(150);
  display.clearDisplay();
}

void loop() {
  //NOTES
  //tone(sound,200,50); This is what you use to do a sound. The firs tnumber is pitch, lower number is deeper and vce versa. Second number is duration.
  //if(button1State == ACTIVATED; This is what yo uuse for button push
  //digitalWrite(light,HIGH/LOW); for LED on / off

  display.clearDisplay();
  
  button1State = digitalRead(button1Pin);
  button2State = digitalRead(button2Pin);
  button3State = digitalRead(button3Pin);
  button4State = digitalRead(button4Pin);
  
  if(button1State==ACTIVATED){ //RANDOM FEELING
    switch(random(1,7)){
      case 1:
        display.clearDisplay();
        wow();
        display.display();
        tone(sound,550,1000);
        delay(1000);
      break;
      case 2:
        display.clearDisplay();
        meh();
        display.display();
        tone(sound,300,1000);
        delay(1000);
      break;
      case 3:
        display.clearDisplay();
        wink();
        display.display();
        tone(sound,650,1000);
        delay(1000);
      break;
      case 4:
        display.clearDisplay();
        left();
        display.display();
        tone(sound,200,1000);
        delay(1000);
      break;
      case 5:
        display.clearDisplay();
        crazy();
        display.display();
        tone(sound,700,1000);
        delay(1000);
      break;
      case 6:
        display.clearDisplay();
        happy();
        display.display();
        tone(sound,500,1000);
        delay(1000);
      break;
    }
    lastActivity = millis();
    
  }else if(button2State==ACTIVATED){ //RANDOM OPTION
    speak(generator1());
    speak(generator2());
    lastActivity = millis();
    
  } else { // STANDING
    display.clearDisplay();
    currentTime = millis();
    neutral();
    display.display();

    if((currentTime - lastActivity) > period){ //Inactive
      display.clearDisplay();
      meh();
      display.display();
      delay(3000);
      display.clearDisplay();
      left();
      display.display();
      delay(1000);
      display.clearDisplay();
      right();
      display.display();
      delay(1000);
      lastActivity = millis();
    }

    if((currentTime - lastBlink) > blinkPeriod){ //Blink timer
      display.clearDisplay();
      blink();
      display.display();
      delay(500);
      lastBlink = millis();
    }
  }
  
  display.display();
}
